<?php

namespace Ems\portalGestor\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;

class VinculoRepository {
    /** @var Connection */
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function get(
        int $nrOrg,
        int $nrVinculo
    ) {
        $sql = <<<SQL
            SELECT
                VM.*
            FROM
                GPE_VINCULOM VM
            WHERE
                VM.NRORG = :P_NRORG AND
                VM.NRVINCULOM = :P_NRVINCULO
SQL;

        $params = [
            'P_NRORG' => $nrOrg,
            'P_NRVINCULO' => $nrVinculo,
        ];

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        $vinculo = $std->fetch();

        return $vinculo;
    }
}