/* Sistemas Integrados TEKNISA
Nome: 0100_SDXSTP0_SDX_GERA_NOTAFISCAL.SQL

@C:\Web_550\Sql\End_Conv\Oracle\Clientes\Sdx\0100_SDXSTPO_SDX_GERA_NOTAFISCAL.sql

Descrio:           
Rotina para gerao de notas fiscais a partir de tabelas temporrias

Criao:
05/10/2009 - Cleison Rafael da Silva Ferreira                       
*/

CREATE OR REPLACE PROCEDURE SDX_GERA_NOTAFISCAL
(
        P_CDFILIAL       IN SDX_NOTAFISCAL.CDFILIAL%TYPE,
        P_CDNOTAFISCORIG IN SDX_NOTAFISCAL.CDNOTAFISCORIG%TYPE)
AS
   V_CDINSCESTA				VARCHAR2(16);
   V_CDINSCMUNI				VARCHAR2(16);
   V_NRLANCTONF				VARCHAR2(20);
   V_CDFILIMOVI      		VARCHAR2(04);
   V_CDPRODUTO					VARCHAR2(10);
   V_NRSEQITPROD				VARCHAR2(04);
   V_DSPRODEMIS				VARCHAR2(50);
   V_NRLANCESTQ				VARCHAR2(20);
   V_CDFORNECED				VARCHAR2(21);
   V_CDCLIENTE					VARCHAR2(21);
   V_IDTPIJURNF				VARCHAR2(01);
   V_CDSERIEENTR				VARCHAR2(05);
   V_CDSERIE					VARCHAR2(05);
   V_IDSISTEMA					VARCHAR2(03);
   V_IDORIGDESTNF				VARCHAR2(01);
   V_CDFILIAL					VARCHAR2(04);
   V_CDEMPRESA					VARCHAR2(02);
   V_NRLANCCONT				VARCHAR2(12);
   V_NRSEQLANC					VARCHAR2(05);
   V_IDTPLANCDESC				VARCHAR2(01);
   V_VRDESCITEM				NUMBER;
   V_VRDESPERITEM				NUMBER;
   V_VRFATOCONV				NUMBER;
   V_VRPRODUTOS				NUMBER;
   V_VRNOTAFISC				NUMBER;
   V_DTPROCESSA				DATE;
/*Variveis para baixa da AF*/
   V_AF_CDPRODUTO				VARCHAR2(20);
   V_AF_CDFILLANC				VARCHAR2(04);
   V_AF_NRAUTOFORN			VARCHAR2(10);
   V_AF_CDMARCA				VARCHAR2(05);
   V_AF_EXISTE					VARCHAR2(01);
   V_AF_QTPROGENTAF			NUMBER;
   V_AF_VRPREUNIAF			NUMBER;
/*Variveis para log de erros*/
   V_EXISTE						VARCHAR2(20);
   V_EITEM						VARCHAR2(01);
   V_EAF							VARCHAR2(01);
   V_EENCARGO					VARCHAR2(01);
   V_EVENC						VARCHAR2(01);
   V_EORIG						VARCHAR2(01);
   V_NFLOG						VARCHAR2(1000);
   V_PRODLOG					VARCHAR2(400);
   V_ENCLOG						VARCHAR2(400);
   V_AFLOG						VARCHAR2(400);
   V_VENCLOG					VARCHAR2(400);
   V_CTB							VARCHAR2(20);
   V_BOL							VARCHAR2(20);
   V_REC							VARCHAR2(20);
   V_IRREG_EST					VARCHAR2(400);
   V_ERRO_AF					VARCHAR2(01);
   V_CDALMOXARIFE				VARCHAR2(06);
   V_CDLOCALESTOQ				VARCHAR2(06);
   V_CDNVPRODUTO				VARCHAR2(01);
   V_IDGERAVENC				VARCHAR2(01);
   V_NRSEQVENREC				VARCHAR2(02);
   V_FILIAL						VARCHAR2(04);
   V_LANCTONF					VARCHAR2(10);
   V_IDOPERDEVONF				VARCHAR2(01);
   V_SEQITNOTA					VARCHAR2(03);
   V_NRITEM						NUMBER;
   V_QTDIASVENREC				NUMBER;
   V_DTENTRSAID				DATE;
   V_CDFILIRECE				VARCHAR2(04);
   V_CDFILIEMIT				VARCHAR2(04);
   V_IDCTRLESTQ				CHAR(1);
   V_IDPRODCTEST				CHAR(1);
   V_COUNTNF					NUMBER;
   V_COUNTIRREG				NUMBER;
   V_CLIENT_INFO				VARCHAR2(64);
   V_CDOPERADOR				VARCHAR2(12);
   V_PRIPROD					VARCHAR2(01);
   V_EXCANINS					VARCHAR2(21);
   V_QUANTDEV					NUMBER;
   V_ENRAFSDUP					VARCHAR2(400);
   V_CAFSDUP					NUMBER;
BEGIN
/*Parametro para verificar apenas produto de nvel completo*/
   V_EXCANINS := NULL;
   SELECT MAX(CDNVPRODUTO)
   INTO V_CDNVPRODUTO
   FROM PRODUTO;
   V_CLIENT_INFO := '';
   V_CDOPERADOR  := '';
/* Retorna o codigo e o nome do operador */
   DBMS_APPLICATION_INFO.READ_CLIENT_INFO(V_CLIENT_INFO);
   V_CDOPERADOR := SUBSTR(V_CLIENT_INFO,1,12);
/*Busca as notas fiscais ainda no importada*/
   FOR C_NF IN (SELECT SDX_NF.CDNOTAFISCORIG, SDX_NF.CDFILIAL,
                       SDX_NF.CDEMPRESA, SDX_NF.NRINSJURNF,
                       SDX_NF.NRNOTAFISC, SDX_NF.DTEMISSAO,
                       SDX_NF.DTENTRSAID, SDX_NF.IDENTRSAIDOP,
                       SDX_NF.CDTIPOOPER, SDX_NF.CDSERIE,
                       SDX_NF.CDMODDOCFISC, SDX_NF.CDFILIEMIT,
                       SDX_NF.CDFILIRECE, SDX_NF.DSOBSERVERROS
                  FROM SDX_NOTAFISCAL SDX_NF, SDX_CONTROLEINT SDX_CT
                 WHERE SDX_NF.CDNOTAFISCORIG = SDX_CT.CDNOTAFISCORIG
                   AND SDX_CT.DTIMPORTACAO IS NULL
                   AND SDX_NF.IDMARCIMPORTA  = 'S'
                   AND SDX_NF.CDNOTAFISCORIG = P_CDNOTAFISCORIG
                   AND SDX_NF.CDFILIAL       = P_CDFILIAL
                   AND SDX_CT.IDINSCANCNF = '1'
                   AND SDX_NF.CDNOTAFISCORIG NOT IN (SELECT SDX_CDNOTAFISCORIG
                                                       FROM NOTAFISCAL
                                                      WHERE SDX_CDNOTAFISCORIG IS NOT NULL)) LOOP

      BEGIN
         SELECT MAX(CDNOTAFISCORIG)
           INTO V_EXCANINS
           FROM SDX_CONTROLEINT
          WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG
            AND IDINSCANCNF    = '2'
            AND DTIMPORTACAO IS NULL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_EXCANINS := NULL;
      END;

      IF V_EXCANINS IS NULL THEN
         V_AF_EXISTE := '0';
   /*Busca a Data de Processamento da Filial*/
         BEGIN
            SELECT DTPROCESSA, NVL(IDCTRLESTQ, 'S')
              INTO V_DTPROCESSA, V_IDCTRLESTQ
              FROM PARAMFILIAL
             WHERE CDFILIAL = C_NF.CDFILIAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_DTPROCESSA := NULL;
               V_IDCTRLESTQ := 'S';
         END;
   /* Rotina para verificar se a filial da nota fiscal controla estoque */
         BEGIN
            SELECT NVL(IDATUESTTPOP, V_IDCTRLESTQ)
              INTO V_IDCTRLESTQ
              FROM TIPOOPERAC
             WHERE IDENTRSAIDOP = C_NF.IDENTRSAIDOP
               AND CDTIPOOPER = C_NF.CDTIPOOPER;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_IDCTRLESTQ := V_IDCTRLESTQ;
         END;
   /*Rotina de verificao de inconsistncias da Nota Fiscal*/
         V_NFLOG := NULL;
         BEGIN
            SELECT COUNT(*)
              INTO V_COUNTNF
              FROM NOTAFISCAL
             WHERE SDX_CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_COUNTNF := 0;
         END;
   /*Impede importao de NF's duplicadas*/
         IF V_COUNTNF = 0 THEN
            BEGIN
               SELECT CDFILIAL
                 INTO V_EXISTE
                 FROM FILIAL
                WHERE CDFILIAL = C_NF.CDFILIAL;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_EXISTE := NULL;
            END;
            IF V_EXISTE IS NULL THEN
               V_NFLOG := V_NFLOG||'Filial '||C_NF.CDFILIAL||' no cadastrada.* ';
            END IF;
            IF NOT C_NF.CDFILIRECE IS NULL THEN
               BEGIN
                  SELECT CDFILIAL
                    INTO V_EXISTE
                    FROM FILIAL
                   WHERE CDFILIAL = C_NF.CDFILIRECE;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_EXISTE := NULL;
               END;
               IF V_EXISTE IS NULL THEN
                  V_NFLOG := V_NFLOG||'Filial de recebimento '||C_NF.CDFILIAL||' no cadastrada.* ';
               END IF;
            END IF;
            IF NOT C_NF.CDFILIEMIT IS NULL THEN
               BEGIN
                  SELECT CDFILIAL
                    INTO V_EXISTE
                    FROM FILIAL
                   WHERE CDFILIAL = C_NF.CDFILIEMIT;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_EXISTE := NULL;
               END;
               IF V_EXISTE IS NULL THEN
                  V_NFLOG := V_NFLOG||'Filial de emissao '||C_NF.CDFILIAL||' no cadastrada.* ';
               END IF;
            END IF;
            BEGIN
               SELECT CDEMPRESA
                 INTO V_EXISTE
                 FROM EMPRESA
                WHERE CDEMPRESA = C_NF.CDEMPRESA;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_EXISTE := NULL;
            END;
            IF V_EXISTE IS NULL THEN
               V_NFLOG := V_NFLOG||'Empresa '||C_NF.CDEMPRESA||' no cadastrada.*';
            END IF;
            BEGIN
               SELECT MAX(I.NRINSJURNF)
                 INTO V_EXISTE
                 FROM (SELECT NRINSJURFILI AS NRINSJURNF
                         FROM FILIAL
                        WHERE NRINSJURFILI = C_NF.NRINSJURNF
                       UNION ALL
                       SELECT NRINSJURFORN AS NRINSJURNF
                         FROM FORNECEDOR
                        WHERE NRINSJURFORN = C_NF.NRINSJURNF
                       UNION ALL
                       SELECT NRINSJURCLIE AS NRINSJURNF
                         FROM CLIENTE
                        WHERE NRINSJURCLIE = C_NF.NRINSJURNF) I;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_EXISTE := NULL;
            END;
            IF V_EXISTE IS NULL THEN
               V_NFLOG := V_NFLOG||'Inscrio Jurdica '||C_NF.NRINSJURNF||' no cadastrada.* ';
            END IF;
            BEGIN
               SELECT CDTIPOOPER
                 INTO V_EXISTE
                 FROM TIPOOPERAC
                WHERE CDTIPOOPER = C_NF.CDTIPOOPER
                  AND IDENTRSAIDOP = C_NF.IDENTRSAIDOP;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_EXISTE := NULL;
            END;
            IF V_EXISTE IS NULL THEN
               V_NFLOG := V_NFLOG||'Tipo de operao '||C_NF.CDTIPOOPER||' no cadastrado.* ';
            END IF;
            IF C_NF.IDENTRSAIDOP = 'E' THEN
               SELECT MAX(CDINSCESTA), MAX(CDINSCMUNI)
                 INTO V_CDINSCESTA, V_CDINSCMUNI
                 FROM EMPRCNTRFIL
                WHERE (CDFILIAL  = C_NF.CDFILIRECE) AND
                      (CDEMPRESA = C_NF.CDEMPRESA);
               IF (V_CDINSCESTA IS NULL) OR (V_CDINSCMUNI IS NULL) THEN
                  SELECT MAX(CDINSCESTA), MAX(CDINSCMUNI)
                    INTO V_CDINSCESTA, V_CDINSCMUNI
                    FROM FILIAL
                   WHERE (CDFILIAL  = C_NF.CDFILIRECE) AND
                         (CDEMPRESA = C_NF.CDEMPRESA);
               END IF;
            ELSE
               SELECT MAX(CDINSCESTA), MAX(CDINSCMUNI)
                 INTO V_CDINSCESTA, V_CDINSCMUNI
                 FROM EMPRCNTRFIL
                WHERE (CDFILIAL  = C_NF.CDFILIEMIT) AND
                      (CDEMPRESA = C_NF.CDEMPRESA);
               IF (V_CDINSCESTA IS NULL) OR (V_CDINSCMUNI IS NULL) THEN
                  SELECT MAX(CDINSCESTA), MAX(CDINSCMUNI)
                    INTO V_CDINSCESTA, V_CDINSCMUNI
                    FROM FILIAL
                   WHERE (CDFILIAL  = C_NF.CDFILIEMIT) AND
                         (CDEMPRESA = C_NF.CDEMPRESA);
               END IF;
            END IF;
            IF C_NF.IDENTRSAIDOP = 'E' THEN
               BEGIN
                  SELECT CDSERIEENTR
                    INTO V_EXISTE
                    FROM SERIEENTR
                   WHERE CDSERIEENTR = C_NF.CDSERIE
                     AND C_NF.IDENTRSAIDOP = 'E';
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_EXISTE := NULL;
               END;
               IF V_EXISTE IS NULL THEN
                  V_NFLOG := V_NFLOG||'Srie de Entrada '||C_NF.CDSERIE||' no cadastrada.* ';
               END IF;
            END IF;
            IF C_NF.IDENTRSAIDOP = 'S' THEN
               BEGIN
                  SELECT MAX(S.CDSERIE)
                    INTO V_EXISTE
                    FROM SERIENF S
                   WHERE S.CDSERIE = C_NF.CDSERIE
                     AND S.CDEMPRESA = C_NF.CDEMPRESA
                     AND S.CDINSCESTA = V_CDINSCESTA
                     AND S.CDINSCMUNI = V_CDINSCMUNI
                     AND C_NF.IDENTRSAIDOP = 'S';
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_EXISTE := NULL;
               END;
               IF V_EXISTE IS NULL THEN
                  V_NFLOG := V_NFLOG||'Srie de Sada '||C_NF.CDSERIE||' no cadastrada.*  ';
               END IF;
               V_CDSERIE      := C_NF.CDSERIE;
               V_IDSISTEMA    := 'DFS';
            END IF;
            BEGIN
               SELECT CDMODDOCFISC
                 INTO V_EXISTE
                 FROM MODDOCFISC
                WHERE CDMODDOCFISC = C_NF.CDMODDOCFISC;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_EXISTE := NULL;
            END;
            IF V_EXISTE IS NULL THEN
               V_NFLOG := V_NFLOG||'Modelo de Documento fiscal '||C_NF.CDMODDOCFISC||' no cadastrado.* ';
            END IF;
   /*Grava o log de erros*/
            IF V_NFLOG IS NOT NULL THEN
               UPDATE SDX_NOTAFISCAL
                  SET DSOBSERVERROS = V_NFLOG
                WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG;
            ELSE
               UPDATE SDX_NOTAFISCAL
                  SET DSOBSERVERROS = ''
                WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG;
   /*Rotina de Importao da Nota Fiscal*/
               V_CDFORNECED  := NULL;
               V_CDCLIENTE   := NULL;
               V_IDTPIJURNF  := NULL;
               V_CDSERIEENTR := NULL;
               V_CDSERIE     := NULL;
               NOVO_CODIGO('LANCNF/FILIAL' || C_NF.CDFILIAL, V_NRLANCTONF);
               V_NRLANCTONF := SUBSTR(V_NRLANCTONF, 11, 10);
              IF V_IDCTRLESTQ = 'S' THEN
                 NOVO_CODIGO('LANCTOEST' || C_NF.CDFILIAL, V_NRLANCESTQ);
                 V_NRLANCESTQ := SUBSTR(V_NRLANCESTQ, 11, 10);
              END IF;
              SELECT DECODE(C_NF.IDENTRSAIDOP, 'E', NVL(IDORIGDESTOP,'F'), NVL(IDORIGDESTOP,'C'))
                INTO V_IDORIGDESTNF
                FROM TIPOOPERAC
               WHERE IDENTRSAIDOP = C_NF.IDENTRSAIDOP
                 AND CDTIPOOPER   = C_NF.CDTIPOOPER;
              IF V_IDORIGDESTNF = 'F' THEN
                 SELECT MAX(CDFORNECED), MAX(IDTPIJURFORN)
                   INTO V_CDFORNECED, V_IDTPIJURNF
                   FROM FORNECEDOR
                  WHERE NRINSJURFORN = C_NF.NRINSJURNF;
              ELSIF V_IDORIGDESTNF = 'L' THEN
                 SELECT MAX(IDTPIJURFILI)
                   INTO V_IDTPIJURNF
                   FROM FILIAL
                  WHERE CDFILIAL = DECODE(C_NF.IDENTRSAIDOP, 'E', C_NF.CDFILIEMIT, C_NF.CDFILIRECE);
              ELSE
                 SELECT MAX(CDCLIENTE), MAX(IDTPIJURCLIE)
                   INTO V_CDCLIENTE, V_IDTPIJURNF
                   FROM CLIENTE
                  WHERE NRINSJURCLIE = C_NF.NRINSJURNF;
              END IF;
              IF C_NF.IDENTRSAIDOP = 'S' THEN
                 V_CDSERIE     := C_NF.CDSERIE;
                 V_IDSISTEMA   := 'DFS';
              ELSE
                 V_CDSERIEENTR := C_NF.CDSERIE;
                 V_IDSISTEMA   := 'DFE';
              END IF;
              INSERT INTO NOTAFISCAL
                (CDFILIAL,     NRLANCTONF,        CDEMPRESA,     CDINSCESTA,
                 CDINSCMUNI,   CDFILIEMIT,        CDFILIRECE,    NRINSJURNF,
                 IDBLOQUEADO,  IDDOCFISCAL,       IDDOCFINANC,   DTENTRSAID,
                 VRPRODUTOS,   VRNOTAFISC,        IDENTRSAIDOP,  CDTIPOOPER,
                 CDSERIE,      IDDOCCONTAB,       IDSTATUS,      IDDOCFISCENT,
                 CDMODDOCFISC, DTEMISSAO,
                 CDFORNECED,   CDCLIENTE,         IDTPIJURNF,    NRNOTAFISC,
                 CDSERIEENTR,  IDSISTEMA,         IDORIGDESTNF,  SDX_CDNOTAFISCORIG)
              VALUES
                 (C_NF.CDFILIAL,     V_NRLANCTONF,      C_NF.CDEMPRESA,    V_CDINSCESTA,
                  V_CDINSCMUNI,      C_NF.CDFILIEMIT,   C_NF.CDFILIRECE,   C_NF.NRINSJURNF,
                  'S',               'S',               'S',               TRUNC(C_NF.DTENTRSAID),
                  0,                 0,                 C_NF.IDENTRSAIDOP, C_NF.CDTIPOOPER,
                  V_CDSERIE,         'S',               DECODE(C_NF.IDENTRSAIDOP,'S','A','P'), 'N',
                  C_NF.CDMODDOCFISC, TRUNC(C_NF.DTEMISSAO),
                  V_CDFORNECED,      V_CDCLIENTE,       V_IDTPIJURNF,      C_NF.NRNOTAFISC,
                  V_CDSERIEENTR,     V_IDSISTEMA,       V_IDORIGDESTNF,    NULL);
   /*Rotina de importao dos vencimentos*/
              V_EVENC := '0';
              IF C_NF.IDENTRSAIDOP = 'S' THEN
                 V_NRSEQVENREC := '01';
                 SELECT IDGERAVENC
                   INTO V_IDGERAVENC
                   FROM TIPOOPERAC
                  WHERE CDTIPOOPER = C_NF.CDTIPOOPER
                    AND IDENTRSAIDOP = C_NF.IDENTRSAIDOP;
                 IF V_IDGERAVENC = 'S' THEN
   /*ROTINA DE IMPORTAO*/
                   FOR C_VENC IN (SELECT CDNOTAFISCORIG, DTORIGVENREC,
                                         VRORIGREC
                                    FROM SDX_CONTARECEBER
                                   WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG
                                   ORDER BY DTORIGVENREC) LOOP
                      V_VENCLOG := NULL;
                      IF TRUNC(C_VENC.DTORIGVENREC) < TRUNC(C_NF.DTEMISSAO) THEN
                         V_VENCLOG := V_VENCLOG||' Vencimento '||C_VENC.DTORIGVENREC||' anterior a data de emisso.* ';
                      END IF;
                      IF V_VENCLOG IS NOT NULL THEN
                         V_EVENC := '1';
                         UPDATE SDX_NOTAFISCAL
                            SET DSOBSERVERROS = DSOBSERVERROS||V_VENCLOG
                          WHERE CDNOTAFISCORIG = C_VENC.CDNOTAFISCORIG;
                      ELSE
                         V_QTDIASVENREC := TO_NUMBER((TRUNC(C_VENC.DTORIGVENREC)-TRUNC(C_NF.DTEMISSAO)));
                         INSERT INTO CONTARECEBER
                           (CDFILIAL, NRLANCTONF, NRSEQVENREC, NRPARCELAREC,
                            QTDIASVENREC, DTORIGVENREC, VRORIGREC, DTATUAVENREC,
                            VRATUAREC, IDSTATREC)
                         VALUES
                           (C_NF.CDFILIAL, V_NRLANCTONF, V_NRSEQVENREC, '00',
                            V_QTDIASVENREC, C_VENC.DTORIGVENREC, C_VENC.VRORIGREC, C_VENC.DTORIGVENREC,
                            C_VENC.VRORIGREC, 'A');
                           V_NRSEQVENREC := LPAD((TO_NUMBER(V_NRSEQVENREC) + 1), 2, 0);
                      END IF;
                   END LOOP;
                 END IF;
              END IF;
   /*Se ocorreu algum erro, deleta os vencimentos e a nota fiscal*/
              IF V_EVENC = '1' THEN
                 DELETE FROM CONTARECEBER
                  WHERE NRLANCTONF = V_NRLANCTONF
                    AND CDFILIAL   = C_NF.CDFILIAL;
                 DELETE FROM NOTAFISCAL
                  WHERE NRLANCTONF = V_NRLANCTONF
                    AND CDFILIAL   = C_NF.CDFILIAL;
              END IF;
              IF V_EVENC = '0' THEN
   /*Rotina de importao das AFs*/
                 V_EAF := '0';
                 FOR C_AF IN (SELECT CDNOTAFISCORIG, CDFILIAL, NRINSJURNF,
                                     CDPEDCOMPRA, DTENTREGA, CDPRODUTO
                                FROM SDX_AFRELACNF
                               WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG) LOOP
   /*Rotina de verificao de inconsistncias*/
                    V_AFLOG := NULL;
                    BEGIN
                       SELECT CDFILIAL
                         INTO V_EXISTE
                         FROM FILIAL
                        WHERE CDFILIAL = C_AF.CDFILIAL;
                    EXCEPTION
                       WHEN NO_DATA_FOUND THEN
                          V_EXISTE := NULL;
                    END;
                    IF V_EXISTE IS NULL THEN
                       V_AFLOG := V_AFLOG||'Filial '||C_AF.CDFILIAL||' no cadastrada.* ';
                    END IF;
                    BEGIN
                       SELECT CDPRODUTO
                         INTO V_EXISTE
                         FROM PRODUTO
                         WHERE CDARVPROD = C_AF.CDPRODUTO
                           AND CDNVPRODUTO = V_CDNVPRODUTO;
                    EXCEPTION
                       WHEN NO_DATA_FOUND THEN
                          V_EXISTE := NULL;
                    END;
                    IF V_EXISTE IS NULL THEN
                       V_AFLOG := V_AFLOG||'Produto '||C_AF.CDPRODUTO||' no cadastrado.* ';
                    END IF;
                    BEGIN
                       SELECT MAX(I.NRINSJURNF)
                         INTO V_EXISTE
                         FROM (SELECT NRINSJURFILI AS NRINSJURNF
                                 FROM FILIAL
                                WHERE NRINSJURFILI = C_AF.NRINSJURNF
                               UNION ALL
                               SELECT NRINSJURFORN AS NRINSJURNF
                                 FROM FORNECEDOR
                                WHERE NRINSJURFORN = C_AF.NRINSJURNF
                               UNION ALL
                               SELECT NRINSJURCLIE AS NRINSJURNF
                                 FROM CLIENTE
                                WHERE NRINSJURCLIE = C_AF.NRINSJURNF) I;
                    EXCEPTION
                       WHEN NO_DATA_FOUND THEN
                          V_EXISTE := NULL;
                    END;
                    IF V_EXISTE IS NULL THEN
                       V_AFLOG := V_AFLOG||'Inscrio Jurdica '||C_AF.NRINSJURNF||' no cadastrada.* ';
                    END IF;
                    V_ENRAFSDUP := 'Erro de AF.* ';
                    IF V_AFLOG IS NULL THEN
                       V_ENRAFSDUP := '';
                       V_CAFSDUP := 0;
	                    FOR C_VERIDUPLAF IN (SELECT IT.NRAUTOFORN
                       								 INTO V_CAFSDUP
   	                 								 FROM ITEMAUTF IT, PRODUTO PR
															WHERE C_AF.CDFILIAL     = IT.CDFILDEST
         	         						        AND C_AF.CDPEDCOMPRA  = IT.SDX_CDPEDCOMPRA
							                          AND C_AF.CDPRODUTO    = PR.CDARVPROD
               	   						        AND C_AF.DTENTREGA    = IT.DTPROGENTAF
							                          AND IT.CDPRODUTO      = PR.CDPRODUTO) LOOP
                    		  IF V_CAFSDUP > 0 THEN
                             V_ENRAFSDUP := V_ENRAFSDUP || ', ';
                          END IF;
                          V_ENRAFSDUP := V_ENRAFSDUP || C_VERIDUPLAF.NRAUTOFORN;
                          V_CAFSDUP   := V_CAFSDUP + 1;
                       END LOOP;
	                    IF V_CAFSDUP > 1 THEN
                          V_AFLOG     := V_AFLOG||' ';
   	                    V_ENRAFSDUP := 'Existe(m) AF(s) ('||V_ENRAFSDUP||') duplicada(s) para o pedido de compra '||C_AF.CDPEDCOMPRA||'.';
                       END IF;
                    END IF;
                    /*Grava o log de erro para as AF's*/
                    IF V_AFLOG IS NOT NULL THEN
                       V_EAF := '1';
                       IF V_CAFSDUP < 2 THEN
                          UPDATE SDX_AFRELACNF
                             SET DSOBSERVERROS  = V_AFLOG
                           WHERE CDNOTAFISCORIG = C_AF.CDNOTAFISCORIG
                             AND CDPEDCOMPRA    = C_AF.CDPEDCOMPRA
                             AND CDPRODUTO      = C_AF.CDPRODUTO
                             AND DTENTREGA      = C_AF.DTENTREGA;
                       END IF;
                       UPDATE SDX_NOTAFISCAL
                          SET DSOBSERVERROS = 'Operao Bloqueada!'||' '||V_ENRAFSDUP
                        WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG;
                    ELSE
                       UPDATE SDX_AFRELACNF
                          SET DSOBSERVERROS  = ''
                        WHERE CDNOTAFISCORIG = C_AF.CDNOTAFISCORIG
                          AND CDPEDCOMPRA    = C_AF.CDPEDCOMPRA
                          AND CDPRODUTO      = C_AF.CDPRODUTO
                          AND DTENTREGA      = C_AF.DTENTREGA;
                       /*Importao das AF's*/
                       BEGIN
                           SELECT IT.CDPRODUTO, IT.CDFILLANC,
                                  IT.NRAUTOFORN, IT.CDMARCA,
                                  (NVL(IT.QTPROGENTAF,0)) AS QTPROGENTAF,
                                  (NVL(IT.VRPREUNIAF,0)) AS VRPREUNIAF
                             INTO V_AF_CDPRODUTO, V_AF_CDFILLANC,
                                  V_AF_NRAUTOFORN, V_AF_CDMARCA,
                                  V_AF_QTPROGENTAF, V_AF_VRPREUNIAF
                             FROM ITEMAUTF IT, PRODUTO PR
                            WHERE C_AF.CDFILIAL       = IT.CDFILDEST
                              AND C_AF.CDPEDCOMPRA    = IT.SDX_CDPEDCOMPRA
                              AND C_AF.CDPRODUTO      = PR.CDARVPROD
                              AND C_AF.DTENTREGA      = IT.DTPROGENTAF
                              AND IT.CDPRODUTO        = PR.CDPRODUTO;
                       EXCEPTION
                          WHEN NO_DATA_FOUND THEN
                           V_AF_CDPRODUTO := NULL;
                       END;
                       IF V_AF_CDPRODUTO IS NOT NULL THEN
                          V_AF_EXISTE := '1';
                          INSERT INTO NFRELACAF
                             (CDFILIAL, CDFILLANC, NRLANCTONF, CDFILDEST,
                              NRAUTOFORN, CDPRODUTO, CDMARCA,
                              DTPROGENTAF, QTNFRELACAF, VRNFRELACAF)
                          VALUES
                             (C_AF.CDFILIAL, V_AF_CDFILLANC, V_NRLANCTONF, C_AF.CDFILIAL,
                              V_AF_NRAUTOFORN, V_AF_CDPRODUTO, V_AF_CDMARCA,
                              C_AF.DTENTREGA, V_AF_QTPROGENTAF, V_AF_VRPREUNIAF);
                       END IF;
                    END IF;
                 END LOOP;
   /*Se houver erro em alguma AF, deleta a nota, os itens e as AF's importados*/
                 IF V_EAF = '1' THEN
                     DELETE FROM NFRELACAF
                      WHERE NRLANCTONF = V_NRLANCTONF
                        AND CDFILIAL   = C_NF.CDFILIAL;
                     DELETE FROM CONTARECEBER
                      WHERE NRLANCTONF = V_NRLANCTONF
                        AND CDFILIAL   = C_NF.CDFILIAL;
                     DELETE FROM NOTAFISCAL
                      WHERE NRLANCTONF = V_NRLANCTONF
                        AND CDFILIAL   = C_NF.CDFILIAL;
                 END IF;
                 IF V_EAF = '0' THEN
   /*Rotina de Importao dos Itens da Nota*/
                   V_VRPRODUTOS := 0;
                   V_VRNOTAFISC := 0;
                   V_NRSEQITPROD := '0001';
                   V_EITEM := '0';
   /*Verifica se a nota fiscal  de devoluo*/
                   BEGIN
                      SELECT IDOPERDEVONF
                        INTO V_IDOPERDEVONF
                        FROM TIPOOPERAC
                       WHERE CDTIPOOPER = C_NF.CDTIPOOPER
                         AND IDENTRSAIDOP = C_NF.IDENTRSAIDOP;
                   EXCEPTION
                      WHEN NO_DATA_FOUND THEN
                         V_IDOPERDEVONF := NULL;
                   END;
   /*Rotina de importao de itens com documento de origem*/
                   IF V_IDOPERDEVONF = 'S' THEN
                      V_SEQITNOTA := '001';
                      FOR C_ORIG IN (SELECT CDNOTAFISCORIG, CDNFORIGEM,
                                            CDSERIEORIG, DTENTRORIG, NRINSJURORIG
                                       FROM SDX_ITEMNOTAFISC
                                      WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG) LOOP
                         BEGIN
                            SELECT CDFILIAL, NRLANCTONF
                              INTO V_FILIAL, V_LANCTONF
                              FROM NOTAFISCAL
                             WHERE NRNOTAFISC = C_ORIG.CDNFORIGEM
                               AND CDSERIEENTR = C_ORIG.CDSERIEORIG
                               AND NRINSJURNF = C_ORIG.NRINSJURORIG
                               AND IDENTRSAIDOP = 'E'
                               AND TRUNC(DTENTRSAID) = TRUNC(C_ORIG.DTENTRORIG);
                         EXCEPTION
                            WHEN NO_DATA_FOUND THEN
                               V_FILIAL := NULL;
                               V_LANCTONF := NULL;
                         END;
                         IF (V_FILIAL IS NULL) OR (V_FILIAL = '') THEN
                            V_EITEM := '1';
                            IF V_NFLOG IS NULL THEN
                               V_NFLOG := '';
                            END IF;
                            UPDATE SDX_NOTAFISCAL
                               SET DSOBSERVERROS = V_NFLOG ||' Nota fiscal de origem no cadastrada. Data de Entrada:'||TRUNC(C_ORIG.DTENTRORIG)||';Srie:'
                                                   ||C_ORIG.CDSERIEORIG||';Nmero NF:'||C_ORIG.CDNFORIGEM||'.* '
                             WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG;
                         ELSE
                            FOR C_ITORIG IN (SELECT DISTINCT I.CDPRODUTO, E.CDARVPROD, (ROUND(I.VRUNITITEM/P.VRFATOCONV,2)) AS VRUNITITEM,
                                                    ROUND(I.VRUNITITEM,2) AS VRUNITENTR
                                               FROM PRODUTO P, ITEMPRODUTO I, PRODUTO E
                                              WHERE I.CDFILIAL = V_FILIAL
                                                AND I.NRLANCTONF = V_LANCTONF
                                                AND P.CDPRODESTO = E.CDPRODUTO
                                                AND P.CDPRODUTO = I.CDPRODUTO) LOOP
                                  FOR C_ITEM IN (SELECT SI.CDNOTAFISCORIG, SI.CDFILIAL, SI.CDPRODUTO,
                                                        (NVL(SI.QTITEMPROD,0)) AS QTITEMPROD,
                                                        (NVL(SI.VRUNITITEM,0)) AS VRUNITITEM,
                                                        (NVL(SI.VRUNITITEM*P.VRFATOCONV,0)) AS VRUNITITEMFAT,
                                                        (NVL(SI.VRDESCITEM,0)) AS VRDESCITEM,
                                                        (NVL(SI.VRTOTAITEM,0)) AS VRTOTAITEM,
                                                        SI.CDFISOPEITEM, SI.CDSITUTRIBPR, SI.CDALMOXARIFE,
                                                        SI.CDLOCALESTOQ, SI.NRLOTEESTQ,
                                                        SI.NRSUBLOTE, SI.DSOBSERVERROS
                                                   FROM SDX_ITEMPRODUTO SI, PRODUTO P, PRODUTO R
                                                  WHERE SI.CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG
                                                    AND SI.CDPRODUTO = C_ITORIG.CDARVPROD
                                                    AND SI.CDPRODUTO = P.CDPRODUTO
                                                    AND R.CDARVPROD = C_ITORIG.CDPRODUTO
                                                    AND ((ROUND(SI.VRUNITITEM,2) BETWEEN (C_ITORIG.VRUNITITEM - 0.05) AND (C_ITORIG.VRUNITITEM + 0.05))
                                                    AND (ROUND(SI.VRUNITITEM*R.VRFATOCONV,2) BETWEEN ROUND(C_ITORIG.VRUNITENTR - 0.05,2) AND ROUND(C_ITORIG.VRUNITENTR + 0.05,2)))) LOOP
   /*Rotina de verificao de inconsistncias*/
                                  V_PRODLOG := NULL;
                                  IF C_ITEM.CDALMOXARIFE IS NULL THEN
                                     V_CDALMOXARIFE := ' ';
                                  ELSE
                                     V_CDALMOXARIFE := C_ITEM.CDALMOXARIFE;
                                  END IF;
                                  IF C_ITEM.CDLOCALESTOQ IS NULL THEN
                                     V_CDLOCALESTOQ := ' ';
                                  ELSE
                                     V_CDLOCALESTOQ := C_ITEM.CDLOCALESTOQ;
                                  END IF;
                                  BEGIN
                                     SELECT CDFILIAL
                                       INTO V_EXISTE
                                       FROM FILIAL
                                      WHERE CDFILIAL = C_ITEM.CDFILIAL;
                                  EXCEPTION
                                     WHEN NO_DATA_FOUND THEN
                                        V_EXISTE := NULL;
                                  END;
                                  IF V_EXISTE IS NULL THEN
                                     V_PRODLOG := V_PRODLOG||'Filial '||C_ITEM.CDFILIAL||' no cadastrada.* ';
                                  END IF;
                                  BEGIN
                                     SELECT CDPRODUTO
                                       INTO V_EXISTE
                                       FROM PRODUTO
                                      WHERE CDARVPROD = C_ITEM.CDPRODUTO
                                        AND CDNVPRODUTO = V_CDNVPRODUTO;
                                  EXCEPTION
                                     WHEN NO_DATA_FOUND THEN
                                        V_EXISTE := NULL;
                                  END;
                                  IF V_EXISTE IS NULL THEN
                                     V_PRODLOG := V_PRODLOG||'Produto '||C_ITEM.CDPRODUTO||' no cadastrado.* ';
                                  END IF;
                                  BEGIN
                                     SELECT CDALMOXARIFE
                                       INTO V_EXISTE
                                       FROM ALMOXARIFADO
                                      WHERE CDFILIAL     = C_ITEM.CDFILIAL
                                        AND CDALMOXARIFE = V_CDALMOXARIFE;
                                  EXCEPTION
                                     WHEN NO_DATA_FOUND THEN
                                        V_EXISTE := NULL;
                                  END;
                                  IF V_EXISTE IS NULL THEN
                                     V_PRODLOG := V_PRODLOG||'Almoxarifado '||V_CDALMOXARIFE||' no cadastrado.* ';
                                  END IF;
                                  BEGIN
                                     SELECT CDLOCALESTOQ
                                       INTO V_EXISTE
                                       FROM LOCALESTOQUE
                                      WHERE CDFILIAL = C_ITEM.CDFILIAL
                                        AND CDALMOXARIFE = V_CDALMOXARIFE
                                        AND CDLOCALESTOQ = V_CDLOCALESTOQ;
                                  EXCEPTION
                                     WHEN NO_DATA_FOUND THEN
                                        V_EXISTE := NULL;
                                  END;
                                  IF V_EXISTE IS NULL THEN
                                     V_PRODLOG := V_PRODLOG||'Localizao '||V_CDLOCALESTOQ||' no cadastrada.* ';
                                  END IF;
   /*Grava o log de erros para o item importado*/
                                  IF V_PRODLOG IS NOT NULL THEN
                                     V_EITEM := '1';
                                     UPDATE SDX_ITEMPRODUTO
                                        SET DSOBSERVERROS  = V_PRODLOG
                                      WHERE CDNOTAFISCORIG = C_ITEM.CDNOTAFISCORIG
                                        AND CDPRODUTO      = C_ITEM.CDPRODUTO
                                        AND VRUNITITEM     = C_ITEM.VRUNITITEM;
                                  ELSE
                                     UPDATE SDX_ITEMPRODUTO
                                        SET DSOBSERVERROS  = ''
                                      WHERE CDNOTAFISCORIG = C_ITEM.CDNOTAFISCORIG
                                        AND CDPRODUTO      = C_ITEM.CDPRODUTO
                                        AND VRUNITITEM     = C_ITEM.VRUNITITEM;
   /*Importao dos Itens da Nota*/
                                     IF (C_NF.IDENTRSAIDOP = 'S') THEN
                                         V_CDFILIMOVI := C_NF.CDFILIEMIT;
                                     ELSE
                                         V_CDFILIMOVI := C_NF.CDFILIRECE;
                                     END IF;
                                     SELECT MAX(CDARVPROD), MAX(VRFATOCONV), MAX(NMPRODUTO)
                                       INTO V_CDPRODUTO, V_VRFATOCONV, V_DSPRODEMIS
                                       FROM PRODUTO
                                      WHERE CDPRODUTO = C_ITORIG.CDPRODUTO;
                                     SELECT NVL(IDTPLANCDESC,'V')
                                       INTO V_IDTPLANCDESC
                                       FROM PARAMGERAL;
                                     IF V_IDTPLANCDESC = 'V' THEN
                                       V_VRDESCITEM := C_ITEM.VRDESCITEM;
                                       IF C_ITEM.VRTOTAITEM > 0  THEN
                                          V_VRDESPERITEM := ROUND((C_ITEM.VRDESCITEM * 100)/C_ITEM.VRTOTAITEM, 4);
                                       ELSE
                                          V_VRDESPERITEM := 0;
                                       END IF;
                                     ELSE
                                       IF C_ITEM.VRDESCITEM > 0  THEN
                                          V_VRDESPERITEM := C_ITEM.VRDESCITEM;
                                          V_VRDESCITEM := ROUND(((C_ITEM.VRUNITITEM * C_ITEM.VRDESCITEM) / 100) * C_ITEM.QTITEMPROD, 4);
                                       ELSE
                                          V_VRDESPERITEM := 0;
                                          V_VRDESCITEM := 0;
                                       END IF;
                                     END IF;
                                     INSERT INTO ITEMPRODUTO
                                        (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,
                                         CDPRODEMIS,   DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,
                                         VRUNITITEM,   VRDESCITEM,   VRTOTAITEM,   VRCONTITEM,
                                         IDCONFORITEM, VRBRUTITEM,   VRDESPERITEM, CDFILIMOVI,
                                         CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
                                         CDMARCA)
                                     VALUES
                                        (C_ITEM.CDFILIAL,   V_NRLANCTONF,      V_NRSEQITPROD,  C_ITORIG.CDPRODUTO,
                                         V_CDPRODUTO,  V_DSPRODEMIS,      'S',            (C_ITEM.QTITEMPROD/V_VRFATOCONV),
                                         C_ITORIG.VRUNITENTR, V_VRDESCITEM, (C_ITORIG.VRUNITENTR*(C_ITEM.QTITEMPROD/V_VRFATOCONV)),
                                                                            (C_ITORIG.VRUNITENTR*(C_ITEM.QTITEMPROD/V_VRFATOCONV)),
                                         'S', (C_ITORIG.VRUNITENTR*(C_ITEM.QTITEMPROD/V_VRFATOCONV)), V_VRDESPERITEM, V_CDFILIMOVI,
                                         V_CDALMOXARIFE,    V_CDLOCALESTOQ,  NVL(C_ITEM.NRLOTEESTQ,' '), NVL(C_ITEM.NRSUBLOTE,' '),
                                         '99999');
                                     IF V_AF_EXISTE = '1' THEN
                                        NF_BAIXA_AF(C_ITEM.CDFILIAL, V_NRLANCTONF, V_NRSEQITPROD, 'I', C_ITEM.CDPRODUTO, C_ITEM.CDPRODUTO,
                                                    V_CDPRODUTO, V_CDPRODUTO, '99999', '99999', C_ITEM.QTITEMPROD, 0, V_ERRO_AF);
                                     END IF;
                                     IF V_ERRO_AF = 'S' THEN
                                        V_EITEM := '1';
                                        V_PRODLOG := V_PRODLOG||'Produto '||C_ITEM.CDPRODUTO||' deve ser oriundo de AF.* ';
                                        UPDATE SDX_NOTAFISCAL
                                           SET DSOBSERVERROS = 'Operao Bloqueada! Erro na importao do item.* '
                                         WHERE CDNOTAFISCORIG = C_ITEM.CDNOTAFISCORIG;
                                        UPDATE SDX_ITEMPRODUTO
                                           SET DSOBSERVERROS  = V_PRODLOG
                                         WHERE CDNOTAFISCORIG = C_ITEM.CDNOTAFISCORIG
                                           AND CDPRODUTO      = C_ITEM.CDPRODUTO
                                           AND VRUNITITEM     = C_ITEM.VRUNITITEM;
                                     END IF;
                                     V_VRPRODUTOS  := V_VRPRODUTOS + C_ITEM.VRTOTAITEM;
                                     V_VRNOTAFISC  := V_VRNOTAFISC + C_ITEM.VRTOTAITEM - V_VRDESCITEM;
                                     V_NRSEQITPROD := LPAD((TO_NUMBER(V_NRSEQITPROD) + 1), 4, 0);
                                  END IF;
                               END LOOP;
                            END LOOP;
                            IF V_EITEM = '0' THEN
										 UPDATE SDX_ITEMPRODUTO
											 SET DSOBSERVERROS = ''
                                WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG;
                               /*Rotina para verificao do valor unitrio do produto e verifica se todos itens da nota foram importados*/
                               FOR C_DEV IN (SELECT P.CDPRODUTO, SI.CDNOTAFISCORIG, SI.VRUNITITEM, SI.DSOBSERVERROS
                                               FROM SDX_ITEMPRODUTO SI, PRODUTO P
                                              WHERE SI.CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG
                                                AND SI.CDPRODUTO = P.CDARVPROD) LOOP
                                  BEGIN
		         							 V_QUANTDEV := 1;
                                     SELECT COUNT(*)
                                       INTO V_QUANTDEV
                                       FROM ITEMPRODUTO I, PRODUTO P
                                      WHERE I.CDFILIAL   = V_FILIAL
                                        AND I.NRLANCTONF = V_LANCTONF
                                        AND I.CDPRODUTO  = P.CDPRODUTO
		            							 AND P.CDPRODESTO = C_DEV.CDPRODUTO
                                        AND ROUND(I.VRUNITITEM/P.VRFATOCONV,2) = ROUND(C_DEV.VRUNITITEM,2);
                                  EXCEPTION
                                     WHEN NO_DATA_FOUND THEN
                                        V_QUANTDEV := 0;
                                  END;
                                  IF V_QUANTDEV = 0 THEN
                                     V_EITEM := '1';
                                     /*Verificar se C_DEV.DSOBSERVERROS  nulo*/
                                     V_PRODLOG := C_DEV.DSOBSERVERROS||'Valor unitrio do produto '||C_DEV.CDPRODUTO||' difere da nota de origem.* ';
                                     UPDATE SDX_ITEMPRODUTO
                                        SET DSOBSERVERROS  = V_PRODLOG
                                      WHERE CDNOTAFISCORIG = C_DEV.CDNOTAFISCORIG
                                        AND CDPRODUTO      = C_DEV.CDPRODUTO
                                        AND VRUNITITEM     = C_DEV.VRUNITITEM;
                                  END IF;
                               END LOOP;
                            END IF;
                            INSERT INTO ITEMNOTAFISC
                              (CDFILIAL, NRLANCTONF, NRSEQUITNOTA, CDFILIALIT, NRLANCTONFIT)
                            VALUES
                              (C_NF.CDFILIAL, V_NRLANCTONF, V_SEQITNOTA, V_FILIAL, V_LANCTONF);
                            SELECT MAX(CDFORNECED)
                              INTO V_CDFORNECED
                              FROM FORNECEDOR
                             WHERE NRINSJURFORN = C_ORIG.NRINSJURORIG;
                            UPDATE NOTAFISCAL
                               SET CDFORNECED = V_CDFORNECED,
                                   NRINSJURNF = C_ORIG.NRINSJURORIG
                             WHERE CDFILIAL   = C_NF.CDFILIAL
                               AND NRLANCTONF = V_NRLANCTONF;
                            V_SEQITNOTA := LPAD((TO_NUMBER(V_SEQITNOTA) + 1), 3, 0);
                         END IF;
                      END LOOP;
   /*Rotina de importao de itens sem documento de origem*/
                   ELSE
                      FOR C_ITEM IN (SELECT CDNOTAFISCORIG, CDFILIAL, CDPRODUTO,
                                            (NVL(QTITEMPROD,0)) AS QTITEMPROD,
                                            (NVL(VRUNITITEM,0)) AS VRUNITITEM,
                                            (NVL(VRDESCITEM,0)) AS VRDESCITEM,
                                            (NVL(VRUNITITEM,0)*NVL(QTITEMPROD,0)) AS VRTOTAITEM,
                                            CDFISOPEITEM, CDSITUTRIBPR, CDALMOXARIFE,
                                            CDLOCALESTOQ, NRLOTEESTQ,
                                            NRSUBLOTE, DSOBSERVERROS
                                       FROM SDX_ITEMPRODUTO
                                      WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG) LOOP
   /*Rotina de verificao de inconsistncias*/
                         V_PRODLOG := NULL;
                         IF C_ITEM.CDALMOXARIFE IS NULL THEN
                            V_CDALMOXARIFE := ' ';
                         ELSE
                            V_CDALMOXARIFE := C_ITEM.CDALMOXARIFE;
                         END IF;
                         IF C_ITEM.CDLOCALESTOQ IS NULL THEN
                            V_CDLOCALESTOQ := ' ';
                         ELSE
                            V_CDLOCALESTOQ := C_ITEM.CDLOCALESTOQ;
                         END IF;
                         BEGIN
                            SELECT CDFILIAL
                              INTO V_EXISTE
                              FROM FILIAL
                             WHERE CDFILIAL = C_ITEM.CDFILIAL;
                         EXCEPTION
                            WHEN NO_DATA_FOUND THEN
                               V_EXISTE := NULL;
                         END;
                         IF V_EXISTE IS NULL THEN
                            V_PRODLOG := V_PRODLOG||'Filial '||C_ITEM.CDFILIAL||' no cadastrada.* ';
                         END IF;
                         BEGIN
                            SELECT CDPRODUTO
                              INTO V_EXISTE
                              FROM PRODUTO
                             WHERE CDARVPROD = C_ITEM.CDPRODUTO
                               AND CDNVPRODUTO = V_CDNVPRODUTO;
                         EXCEPTION
                            WHEN NO_DATA_FOUND THEN
                               V_EXISTE := NULL;
                         END;
                         IF V_EXISTE IS NULL THEN
                            V_PRODLOG := V_PRODLOG||'Produto '||C_ITEM.CDPRODUTO||' no cadastrado.* ';
                         END IF;
                         BEGIN
                            SELECT CDALMOXARIFE
                              INTO V_EXISTE
                              FROM ALMOXARIFADO
                             WHERE CDFILIAL     = C_ITEM.CDFILIAL
                               AND CDALMOXARIFE = V_CDALMOXARIFE;
                         EXCEPTION
                            WHEN NO_DATA_FOUND THEN
                               V_EXISTE := NULL;
                         END;
                         IF V_EXISTE IS NULL THEN
                            V_PRODLOG := V_PRODLOG||'Almoxarifado '||V_CDALMOXARIFE||' no cadastrado.* ';
                         END IF;
                         BEGIN
                            SELECT CDLOCALESTOQ
                              INTO V_EXISTE
                              FROM LOCALESTOQUE
                             WHERE CDFILIAL = C_ITEM.CDFILIAL
                               AND CDALMOXARIFE = V_CDALMOXARIFE
                               AND CDLOCALESTOQ = V_CDLOCALESTOQ;
                         EXCEPTION
                            WHEN NO_DATA_FOUND THEN
                               V_EXISTE := NULL;
                         END;
                         IF V_EXISTE IS NULL THEN
                            V_PRODLOG := V_PRODLOG||'Localizao '||V_CDLOCALESTOQ||' no cadastrada.* ';
                         END IF;
   /*Grava o log de erros para o item importado*/
                         IF V_PRODLOG IS NOT NULL THEN
                            V_EITEM := '1';
                            UPDATE SDX_ITEMPRODUTO
                               SET DSOBSERVERROS  = V_PRODLOG
                             WHERE CDNOTAFISCORIG = C_ITEM.CDNOTAFISCORIG
                               AND CDPRODUTO      = C_ITEM.CDPRODUTO
                               AND VRUNITITEM     = C_ITEM.VRUNITITEM;
                         ELSE
                            UPDATE SDX_ITEMPRODUTO
                               SET DSOBSERVERROS  = ''
                             WHERE CDNOTAFISCORIG = C_ITEM.CDNOTAFISCORIG
                               AND CDPRODUTO      = C_ITEM.CDPRODUTO
                               AND VRUNITITEM     = C_ITEM.VRUNITITEM;
   /*Importao dos Itens da Nota*/
                            IF (C_NF.IDENTRSAIDOP = 'S') THEN
                                V_CDFILIMOVI := C_NF.CDFILIEMIT;
                            ELSE
                                V_CDFILIMOVI := C_NF.CDFILIRECE;
                            END IF;
                            SELECT MAX(CDPRODUTO), MAX(VRFATOCONV), MAX(NMPRODUTO)
                              INTO V_CDPRODUTO, V_VRFATOCONV, V_DSPRODEMIS
                              FROM PRODUTO
                             WHERE CDARVPROD = C_ITEM.CDPRODUTO;
                            SELECT NVL(IDTPLANCDESC,'V')
                              INTO V_IDTPLANCDESC
                              FROM PARAMGERAL;
                            IF V_IDTPLANCDESC = 'V' THEN
                              V_VRDESCITEM := C_ITEM.VRDESCITEM;
                              IF C_ITEM.VRTOTAITEM > 0  THEN
                                 V_VRDESPERITEM := ROUND((C_ITEM.VRDESCITEM * 100)/C_ITEM.VRTOTAITEM, 4);
                              ELSE
                                 V_VRDESPERITEM := 0;
                              END IF;
                            ELSE
                              IF C_ITEM.VRDESCITEM > 0  THEN
                                 V_VRDESPERITEM := C_ITEM.VRDESCITEM;
                                 V_VRDESCITEM := ROUND(((C_ITEM.VRUNITITEM * C_ITEM.VRDESCITEM) / 100) * C_ITEM.QTITEMPROD, 4);
                              ELSE
                                 V_VRDESPERITEM := 0;
                                 V_VRDESCITEM := 0;
                              END IF;
                            END IF;
                            INSERT INTO ITEMPRODUTO
                               (CDFILIAL,     NRLANCTONF,   NRSEQITPROD,  CDPRODUTO,
                                CDPRODEMIS,   DSPRODEMIS,   IDATUVRESTOQ, QTITEMPROD,
                                VRUNITITEM,   VRDESCITEM,   VRTOTAITEM,   VRCONTITEM,
                                IDCONFORITEM, VRBRUTITEM,   VRDESPERITEM, CDFILIMOVI,
                                CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ,   NRSUBLOTE,
                                CDMARCA)
                            VALUES
                               (C_ITEM.CDFILIAL,   V_NRLANCTONF,      V_NRSEQITPROD,  V_CDPRODUTO,
                                C_ITEM.CDPRODUTO,  V_DSPRODEMIS,      'S',            C_ITEM.QTITEMPROD,
                                C_ITEM.VRUNITITEM, V_VRDESCITEM, C_ITEM.VRTOTAITEM, C_ITEM.VRTOTAITEM,
                                'S',               C_ITEM.VRTOTAITEM, V_VRDESPERITEM, V_CDFILIMOVI,
                                V_CDALMOXARIFE,    V_CDLOCALESTOQ,  NVL(C_ITEM.NRLOTEESTQ,' '), NVL(C_ITEM.NRSUBLOTE,' '),
                                '99999');
                            IF V_AF_EXISTE = '1' THEN
                               NF_BAIXA_AF(C_ITEM.CDFILIAL, V_NRLANCTONF, V_NRSEQITPROD, 'I', C_ITEM.CDPRODUTO, C_ITEM.CDPRODUTO,
                                           V_CDPRODUTO, V_CDPRODUTO, '99999', '99999', C_ITEM.QTITEMPROD, 0, V_ERRO_AF);
                            END IF;
                            IF V_ERRO_AF = 'S' THEN
                               V_EITEM := '1';
                               V_PRODLOG := V_PRODLOG||'Produto '||C_ITEM.CDPRODUTO||' deve ser oriundo de AF.* ';
                               UPDATE SDX_NOTAFISCAL
                                 SET DSOBSERVERROS = 'Operao Bloqueada! Erro na importao do item.* '
                               WHERE CDNOTAFISCORIG = C_ITEM.CDNOTAFISCORIG;
                               UPDATE SDX_ITEMPRODUTO
                                  SET DSOBSERVERROS  = V_PRODLOG
                                WHERE CDNOTAFISCORIG = C_ITEM.CDNOTAFISCORIG
                                  AND CDPRODUTO      = C_ITEM.CDPRODUTO
                                  AND VRUNITITEM     = C_ITEM.VRUNITITEM;
                            END IF;
                            V_VRPRODUTOS  := V_VRPRODUTOS + C_ITEM.VRTOTAITEM;
                            V_VRNOTAFISC  := V_VRNOTAFISC + C_ITEM.VRTOTAITEM - V_VRDESCITEM;
                            V_NRSEQITPROD := LPAD((TO_NUMBER(V_NRSEQITPROD) + 1), 4, 0);
                         END IF;
                      END LOOP;
                   END IF;
   /*Se houver erro na importao de algum produto, deleta a nota e os itens importados*/
                   IF V_EITEM = '0' THEN
                      BEGIN
                         SELECT COUNT(*)
                           INTO V_NRITEM
                           FROM ITEMPRODUTO
                          WHERE CDFILIAL = C_NF.CDFILIAL
                            AND NRLANCTONF = V_NRLANCTONF;
                      EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_NRITEM := NULL;
                      END;
                      IF (V_NRITEM = 0 OR V_NRITEM = NULL) THEN
                         V_EITEM := '1';
                         IF V_NFLOG IS NULL THEN
                            V_NFLOG := '';
                         END IF;
                         UPDATE SDX_NOTAFISCAL
                            SET DSOBSERVERROS = V_NFLOG ||' Nota fiscal com itens irregulares.* '
                          WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG;
                      END IF;
                   END IF;
                   IF V_EITEM = '1' THEN
                     DELETE FROM AUDITORIA
                      WHERE CDFILIALNF = C_NF.CDFILIAL
                        AND NRLANCTONF = V_NRLANCTONF;
                     DELETE FROM ITEMPRODUTO
                      WHERE NRLANCTONF = V_NRLANCTONF
                        AND CDFILIAL   = C_NF.CDFILIAL;
                     DELETE FROM ITEMNOTAFISC
                      WHERE NRLANCTONF = V_NRLANCTONF
                        AND CDFILIAL   = C_NF.CDFILIAL;
                     DELETE FROM NFRELACAF
                      WHERE NRLANCTONF = V_NRLANCTONF
                        AND CDFILIAL   = C_NF.CDFILIAL;
                     DELETE FROM CONTARECEBER
                      WHERE NRLANCTONF = V_NRLANCTONF
                        AND CDFILIAL   = C_NF.CDFILIAL;
                     DELETE FROM NOTAFISCAL
                      WHERE NRLANCTONF = V_NRLANCTONF
                        AND CDFILIAL   = C_NF.CDFILIAL;
                   END IF;
                   IF V_EITEM = '0' THEN
   /*Rotina de importao dos Encargos da Nota Fiscal*/
                      V_EENCARGO := '0';
                      IF V_IDOPERDEVONF = 'S' THEN
   /*Busca os encargos da nota de origem e insere na nota de devoluo*/
                         FOR C_ENCORIG IN (SELECT A.CDENCARGO, B.NMENCARGO, SUM(A.VRITEMENCA) AS VRITEMENCA, B.IDENCARGO
                                             FROM ITEMENCARGO A, ENCARGO B
                                            WHERE (B.CDENCARGO = A.CDENCARGO) AND
                                                  (A.CDFILIAL   = V_FILIAL)  AND
                                                  (A.NRLANCTONF = V_LANCTONF)
                                            GROUP BY A.CDENCARGO, B.NMENCARGO, B.IDENCARGO) LOOP
                            INSERT INTO ITEMENCARGO
                               (CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
                            VALUES
                               (C_NF.CDFILIAL, V_NRLANCTONF, C_ENCORIG.CDENCARGO, C_ENCORIG.VRITEMENCA);
                         END LOOP;
                      ELSE
                         FOR C_ITENC IN (SELECT CDNOTAFISCORIG, CDFILIAL,
                                                CDENCARGO, VRITEMENCA, DSOBSERVERROS
                                           FROM SDX_ITEMENCARGO
                                          WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG) LOOP
   /*Rotina de verificao de inconsistncias*/
                            V_ENCLOG := NULL;
                            BEGIN
                               SELECT CDFILIAL
                                 INTO V_EXISTE
                                 FROM FILIAL
                                WHERE CDFILIAL = C_ITENC.CDFILIAL;
                            EXCEPTION
                               WHEN NO_DATA_FOUND THEN
                                  V_EXISTE := NULL;
                            END;
                            IF V_EXISTE IS NULL THEN
                               V_ENCLOG := V_ENCLOG||'Filial '||C_ITENC.CDFILIAL||' no cadastrada.* ';
                            END IF;
                            BEGIN
                               SELECT CDENCARGO
                                 INTO V_EXISTE
                                 FROM ENCARGO
                                WHERE CDENCARGO = C_ITENC.CDENCARGO;
                            EXCEPTION
                               WHEN NO_DATA_FOUND THEN
                                  V_EXISTE := NULL;
                            END;
                            IF V_EXISTE IS NULL THEN
                               V_ENCLOG := V_ENCLOG||'Encargo '||C_ITENC.CDENCARGO||' no cadastrado.* ';
                            END IF;
   /*Grava o log de erro para os encargos*/
                            IF V_ENCLOG IS NOT NULL THEN
                               V_EENCARGO := '1';
                               UPDATE SDX_NOTAFISCAL
                                  SET DSOBSERVERROS = 'Operao Bloqueada! Erro de encargo.* '
                                WHERE CDNOTAFISCORIG = C_ITENC.CDNOTAFISCORIG;
                               UPDATE SDX_ITEMENCARGO
                                  SET DSOBSERVERROS  = V_ENCLOG
                                WHERE CDNOTAFISCORIG = C_ITENC.CDNOTAFISCORIG
                                  AND CDENCARGO      = C_ITENC.CDENCARGO;
                            ELSE
                               UPDATE SDX_ITEMENCARGO
                                  SET DSOBSERVERROS  = ''
                                WHERE CDNOTAFISCORIG = C_ITENC.CDNOTAFISCORIG
                                  AND CDENCARGO      = C_ITENC.CDENCARGO;
   /*Importao dos Encargos da Nota Fiscal*/
                               INSERT INTO ITEMENCARGO
                                  (CDFILIAL, NRLANCTONF, CDENCARGO, VRITEMENCA)
                               VALUES
                                  (C_ITENC.CDFILIAL, V_NRLANCTONF, C_ITENC.CDENCARGO, C_ITENC.VRITEMENCA);
                            END IF;
                         END LOOP;
                      END IF;
   /*Se houver erro em algum encargo, deleta a nota, os itens e os encargos importados*/
                      IF V_EENCARGO = '1' THEN
                         DELETE FROM ITEMENCARGO
                          WHERE NRLANCTONF = V_NRLANCTONF
                            AND CDFILIAL   = C_NF.CDFILIAL;
                         DELETE FROM AUDITORIA
                          WHERE CDFILIALNF = C_NF.CDFILIAL
                            AND NRLANCTONF = V_NRLANCTONF;
                         DELETE FROM ITEMNOTAFISC
                          WHERE NRLANCTONF = V_NRLANCTONF
                            AND CDFILIAL   = C_NF.CDFILIAL;
                         DELETE FROM ITEMPRODUTO
                          WHERE NRLANCTONF = V_NRLANCTONF
                            AND CDFILIAL   = C_NF.CDFILIAL;
                         DELETE FROM NFRELACAF
                          WHERE NRLANCTONF = V_NRLANCTONF
                            AND CDFILIAL   = C_NF.CDFILIAL;
                         DELETE FROM CONTARECEBER
                          WHERE NRLANCTONF = V_NRLANCTONF
                            AND CDFILIAL   = C_NF.CDFILIAL;
                         DELETE FROM NOTAFISCAL
                          WHERE NRLANCTONF = V_NRLANCTONF
                            AND CDFILIAL   = C_NF.CDFILIAL;
                      END IF;
                   END IF;
                 END IF;
              END IF;
   /*Rotina de Gerao dos Impostos da Nota Fiscal*/
              IF ((V_NFLOG IS NULL) AND (V_EITEM = '0') AND (V_EENCARGO = '0')) THEN
   /*Gera os impostos, contas a pagar e atualiza o estoque para notas de entrada*/
                 IF C_NF.IDENTRSAIDOP = 'E' THEN
                    V_CDFILIMOVI  := C_NF.CDFILIRECE;
                    V_IRREG_EST := '0';
                    SDX_TRAB_IMPOSTO_ENTRADA(C_NF.CDFILIAL, V_NRLANCTONF, V_NRLANCESTQ, V_VRNOTAFISC);
                    IF V_VRNOTAFISC = 0 THEN
                       V_COUNTNF := 0;
                       BEGIN
                          SELECT NVL(COUNT(*), 0)
                            INTO V_COUNTNF
                            FROM ITEMPROIMPOS I, IMPOSTO M
                           WHERE I.CDIMPOSTO  = M.CDIMPOSTO
                             AND I.CDFILIAL   = C_NF.CDFILIAL
                             AND I.NRLANCTONF = V_NRLANCTONF
                             AND M.IDTRATIMPO IN ('A','D');
                       EXCEPTION
                          WHEN NO_DATA_FOUND THEN
                             V_COUNTNF := 0;
                       END;
                       IF V_COUNTNF = 0 THEN
                          V_VRNOTAFISC := V_VRPRODUTOS;
                       ELSE
                          V_IRREG_EST := '1';
                           DELETA_NF(C_NF.CDFILIAL, V_NRLANCTONF);
                           UPDATE SDX_NOTAFISCAL
                              SET DSOBSERVERROS = 'Importao bloqueada. Nota Fiscal com valor zerado.'
                            WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG;
                           UPDATE SDX_CONTROLEINT
                              SET DTIMPORTACAO = NULL
                           WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG;
                       END IF;
                    END IF;
                    IF V_IRREG_EST = '0' THEN
                       UPDATE NOTAFISCAL
                          SET VRNOTAFISC = V_VRNOTAFISC,
                          		IDERROS    = '0000',
                          		IDAVISOS	  = '0000'
                        WHERE CDFILIAL   = C_NF.CDFILIAL
                          AND NRLANCTONF = V_NRLANCTONF;
                       GERA_CONTAPAGAR(C_NF.CDFILIAL, V_CDFORNECED, V_NRLANCTONF, 'F');
                       ATUALIZA_ESTOQUE(C_NF.CDFILIRECE, C_NF.DTENTRSAID, C_NF.DTENTRSAID, C_NF.CDFILIAL, V_NRLANCESTQ);
                    END IF;
   /*Gera os impostos, contas a receber e atualiza o estoque para notas de sada*/
                 ELSE
                    IMPOSTO_SAIDA(C_NF.CDEMPRESA, V_CDINSCESTA, C_NF.CDTIPOOPER, V_CDCLIENTE,
                                  C_NF.CDFILIAL,  V_NRLANCTONF, C_NF.DTENTRSAID, V_VRNOTAFISC,
                                  V_NRLANCESTQ);
                     UPDATE NOTAFISCAL
                       SET VRNOTAFISC = V_VRNOTAFISC
                     WHERE CDFILIAL   = C_NF.CDFILIAL
                       AND NRLANCTONF = V_NRLANCTONF;
                     ATUALIZA_ESTOQUE(C_NF.CDFILIEMIT, C_NF.DTENTRSAID, C_NF.DTENTRSAID, C_NF.CDFILIAL, V_NRLANCESTQ);
                     V_CDFILIMOVI  := C_NF.CDFILIEMIT;
                     V_IRREG_EST := '0';
                     IF V_IDCTRLESTQ = 'S' THEN
                        SELECT COUNT(*)
                          INTO V_COUNTIRREG
                          FROM MOVILOTE M, PRODFILI F, PRODUTO P, SDX_ITEMPRODUTO S
                         WHERE M.NRMOVILOTE = C_NF.CDFILIAL||V_NRLANCESTQ
                           AND M.CDFILIAL   = V_CDFILIMOVI
                           AND M.CDPRODUTO  = F.CDPRODUTO(+)
                           AND M.CDFILIAL   = F.CDFILIAL(+)
                           AND P.CDPRODUTO  = M.CDPRODUTO
                           AND S.CDPRODUTO  = P.CDARVPROD
                           AND NVL(M.CDALMOXARIFE,' ') = NVL(S.CDALMOXARIFE, ' ')
                           AND NVL(M.CDLOCALESTOQ,' ') = NVL(S.CDLOCALESTOQ, ' ')
                           AND NVL(F.IDCNTRESTOQ,'S') = 'S';
                        IF V_COUNTIRREG > 0 THEN
                           V_IRREG_EST := '1';
                           V_PRIPROD := '0';
                           FOR C_CANCE IN(SELECT DISTINCT NVL(P.CDARVPROD,'') AS PRODUTO
                                            FROM MOVILOTE M, PRODUTO P, PRODFILI F, SDX_ITEMPRODUTO S
                                           WHERE (NRMOVILOTE  = C_NF.CDFILIAL||V_NRLANCESTQ)
                                             AND (M.CDFILIAL  = V_CDFILIMOVI)
                                             AND (M.CDPRODUTO = F.CDPRODUTO)
                                             AND (M.CDFILIAL  = F.CDFILIAL(+))
                                             AND (M.CDPRODUTO = P.CDPRODUTO(+))
                                             AND (S.CDPRODUTO = P.CDARVPROD)
                                             AND (NVL(M.CDALMOXARIFE,' ') = NVL(S.CDALMOXARIFE, ' '))
                                             AND (NVL(M.CDLOCALESTOQ,' ') = NVL(S.CDLOCALESTOQ, ' '))
                                             AND (NVL(F.IDCNTRESTOQ, 'S') = 'S')) LOOP
                              IF V_PRIPROD = '0' THEN
                                      V_NFLOG := V_NFLOG || 'Lan. geraria irregularidade no estoque produtos: ';
                                      V_PRIPROD := '1';
                                  END IF;
                                  V_NFLOG := V_NFLOG || C_CANCE.PRODUTO || '.* ';
                           END LOOP;
                           UPDATE SDX_NOTAFISCAL
                              SET DSOBSERVERROS = DSOBSERVERROS || V_NFLOG
                            WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG;
                           DELETA_NF(C_NF.CDFILIAL, V_NRLANCTONF);
                           ATUALIZA_ESTOQUE(V_CDFILIMOVI, C_NF.DTENTRSAID, C_NF.DTENTRSAID, C_NF.CDFILIAL, V_NRLANCESTQ);
                           UPDATE SDX_CONTROLEINT
                              SET DTIMPORTACAO = NULL
                           WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG;
                        END IF;
                     END IF;
                 END IF;
   /*Grava a data de importao na tabela de controle*/
                 IF V_IRREG_EST = '0' THEN
                    UPDATE NOTAFISCAL
                       SET SDX_CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG
                     WHERE CDFILIAL = C_NF.CDFILIAL
                       AND NRLANCTONF = V_NRLANCTONF;

                    UPDATE SDX_CONTROLEINT
                       SET DTIMPORTACAO = SYSDATE
                     WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG
                       AND IDINSCANCNF = '1';
                 END IF;
              END IF;
            END IF;
            UPDATE LANCTOESTOQ
               SET CDOPERADOR = V_CDOPERADOR
             WHERE CDFILIAL   = C_NF.CDFILIAL
               AND NRLANCESTQ = V_NRLANCESTQ;
         ELSE
            UPDATE SDX_NOTAFISCAL
               SET DSOBSERVERROS = 'Importao bloqueada. Lanamento geraria duplicidade de notas fiscais.'
             WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG;
         END IF;
      ELSE
         UPDATE SDX_CONTROLEINT
            SET DTIMPORTACAO = SYSDATE
          WHERE CDNOTAFISCORIG = C_NF.CDNOTAFISCORIG;
      END IF;
   END LOOP;
/*Rotina de cancelamento das notas fiscais de Entrada*/
   FOR C_NFENTR IN (SELECT SDX_NF.CDNOTAFISCORIG, SDX_NF.CDFILIAL,
                           SDX_NF.NRINSJURNF, SDX_NF.NRNOTAFISC,
                           SDX_NF.CDSERIE, SDX_NF.CDTIPOOPER, SDX_NF.DTENTRSAID
                      FROM SDX_NOTAFISCAL SDX_NF, SDX_CONTROLEINT SDX_CT
                     WHERE SDX_NF.CDNOTAFISCORIG = SDX_CT.CDNOTAFISCORIG
                       AND SDX_CT.DTIMPORTACAO IS NULL
                       AND SDX_CT.IDINSCANCNF = '2'
                       AND SDX_NF.IDENTRSAIDOP = 'E'
                       AND SDX_NF.CDFILIAL = P_CDFILIAL
                       AND SDX_NF.CDNOTAFISCORIG IN (SELECT SDX_CDNOTAFISCORIG
                                                           FROM NOTAFISCAL
                                                          WHERE SDX_CDNOTAFISCORIG IS NOT NULL)) LOOP
      BEGIN
         SELECT MAX(CDNOTAFISCORIG)
           INTO V_EXCANINS
           FROM SDX_CONTROLEINT
          WHERE CDNOTAFISCORIG = C_NFENTR.CDNOTAFISCORIG
            AND IDINSCANCNF    = '1'
            AND DTIMPORTACAO IS NULL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_EXCANINS := NULL;
      END;
      IF V_EXCANINS IS NULL THEN
         V_IRREG_EST := '';
         V_NFLOG := '';
         BEGIN
            SELECT NVL(IDCTRLESTQ, 'S')
              INTO V_IDCTRLESTQ
              FROM PARAMFILIAL
             WHERE CDFILIAL = C_NFENTR.CDFILIAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_DTPROCESSA := NULL;
               V_IDCTRLESTQ := 'S';
         END;
   /* Rotina para verificar se a filial da nota fiscal controla estoque */
         BEGIN
            SELECT NVL(IDATUESTTPOP, V_IDCTRLESTQ)
              INTO V_IDCTRLESTQ
              FROM TIPOOPERAC
             WHERE IDENTRSAIDOP = 'E'
               AND CDTIPOOPER = C_NFENTR.CDTIPOOPER;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_IDCTRLESTQ := V_IDCTRLESTQ;
         END;
   /*Busca a nota fiscal que ser cancelada*/
         BEGIN
            SELECT N.NRLANCTONF, N.CDFILIAL, L.NRLANCESTQ, N.DTENTRSAID, N.CDFILIRECE
              INTO V_NRLANCTONF, V_CDFILIAL, V_NRLANCESTQ, V_DTENTRSAID, V_CDFILIRECE
              FROM NOTAFISCAL N, LANCTOESTOQ L
             WHERE N.SDX_CDNOTAFISCORIG = C_NFENTR.CDNOTAFISCORIG
               AND N.IDENTRSAIDOP = 'E'
               AND N.CDFILIAL = L.CDFILIAL(+)
               AND N.NRLANCTONF = L.NRLANCTONF(+);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NRLANCTONF := '';
               V_CDFILIAL   := '';
               V_NRLANCESTQ := '';
               V_DTENTRSAID := NULL;
               V_CDFILIRECE := '';
         END;
   /*Verifica se existe movimentao de estoque para essa nota fiscal*/
         IF V_IDCTRLESTQ = 'S' THEN
            V_PRIPROD := '0';
            FOR C_CANCE IN(SELECT DISTINCT NVL(P.CDARVPROD,'') AS PRODUTO
                             FROM MOVILOTE M, PRODUTO P, PRODFILI F, SDX_ITEMPRODUTO S
                            WHERE (NRMOVILOTE  = V_CDFILIAL||V_NRLANCESTQ)
                              AND (M.CDFILIAL  = V_CDFILIAL)
                              AND (M.CDFILIAL  = F.CDFILIAL)
                              AND (M.CDPRODUTO = F.CDPRODUTO(+))
                              AND (M.CDPRODUTO = P.CDPRODUTO(+))
                              AND (S.CDPRODUTO  = P.CDARVPROD)
                              AND (NVL(M.CDALMOXARIFE,' ') = NVL(S.CDALMOXARIFE, ' '))
                              AND (NVL(M.CDLOCALESTOQ,' ') = NVL(S.CDLOCALESTOQ, ' '))
                              AND (NVL(F.IDCNTRESTOQ,'S')='S')) LOOP
   /*Gera mensagem de erro se houver movimentao do produto*/
               IF V_PRIPROD = '0' THEN
                         V_NFLOG := V_NFLOG || 'Lan. geraria irregularidade no estoque produtos: ';
                        V_PRIPROD := '1';
                  END IF;
                  V_NFLOG := V_NFLOG || C_CANCE.PRODUTO || '.* ';
            END LOOP;
         END IF;
   /*Verifica se existe algum impedimento para a excluso*/
         IF ((V_NFLOG = '') OR (V_NFLOG IS NULL)) THEN
   /*Cancela a Nota Fiscal*/
            DELETA_NF(V_CDFILIAL, V_NRLANCTONF);
   /*Grava a data de importao na tabela de controle*/
            UPDATE SDX_CONTROLEINT
               SET DTIMPORTACAO = SYSDATE
             WHERE CDNOTAFISCORIG = C_NFENTR.CDNOTAFISCORIG
               AND IDINSCANCNF = '2';
         ELSE
   /*Grava o log de erros*/
            UPDATE SDX_NOTAFISCAL
               SET DSOBSERVERROS = DSOBSERVERROS || V_NFLOG
             WHERE CDNOTAFISCORIG = C_NFENTR.CDNOTAFISCORIG;
         END IF;
         IF V_IDCTRLESTQ = 'S' THEN
            ATUALIZA_ESTOQUE(V_CDFILIRECE, V_DTENTRSAID, V_DTENTRSAID, V_CDFILIAL, V_NRLANCESTQ);
            SELECT COUNT(*)
              INTO V_COUNTIRREG
              FROM MOVILOTE M, PRODUTO P, PRODFILI F, SDX_ITEMPRODUTO S
             WHERE (NRMOVILOTE  = V_CDFILIAL||V_NRLANCESTQ)
               AND (M.CDFILIAL  = V_CDFILIAL)
               AND (M.CDFILIAL  = F.CDFILIAL)
               AND (M.CDPRODUTO = F.CDPRODUTO(+))
               AND (M.CDPRODUTO = P.CDPRODUTO(+))
               AND (S.CDPRODUTO  = P.CDARVPROD)
               AND (NVL(M.CDALMOXARIFE,' ') = NVL(S.CDALMOXARIFE, ' '))
               AND (NVL(M.CDLOCALESTOQ,' ') = NVL(S.CDLOCALESTOQ, ' '))
               AND (NVL(F.IDCNTRESTOQ,'S')='S');
            IF V_COUNTIRREG > 0 THEN
               V_PRIPROD := '0';
               FOR C_CANCE IN(SELECT DISTINCT NVL(P.CDARVPROD,'') AS PRODUTO
                                FROM MOVILOTE M, PRODUTO P, PRODFILI F, SDX_ITEMPRODUTO S
                               WHERE (NRMOVILOTE  = V_CDFILIAL||V_NRLANCESTQ)
                                 AND (M.CDFILIAL  = V_CDFILIAL)
                                 AND (M.CDFILIAL  = F.CDFILIAL)
                                 AND (M.CDPRODUTO = F.CDPRODUTO(+))
                                 AND (M.CDPRODUTO = P.CDPRODUTO(+))
                                 AND (S.CDPRODUTO  = P.CDARVPROD)
                                 AND (NVL(M.CDALMOXARIFE,' ') = NVL(S.CDALMOXARIFE, ' '))
                                 AND (NVL(M.CDLOCALESTOQ,' ') = NVL(S.CDLOCALESTOQ, ' '))
                                 AND (NVL(F.IDCNTRESTOQ,'S')='S')) LOOP
                    IF V_PRIPROD = '0' THEN
                           V_NFLOG := V_NFLOG || 'Lan. geraria irregularidade no estoque produtos: ';
                            V_PRIPROD := '1';
                        END IF;
                        V_NFLOG := V_NFLOG || C_CANCE.PRODUTO || '.* ';
               END LOOP;
               ROLLBACK;
               UPDATE SDX_NOTAFISCAL
                  SET DSOBSERVERROS = DSOBSERVERROS || V_NFLOG
                WHERE CDNOTAFISCORIG = C_NFENTR.CDNOTAFISCORIG;
               ATUALIZA_ESTOQUE(V_CDFILIRECE, C_NFENTR.DTENTRSAID, C_NFENTR.DTENTRSAID, V_CDFILIAL, V_NRLANCESTQ);
               UPDATE SDX_CONTROLEINT
                  SET DTIMPORTACAO = NULL
               WHERE CDNOTAFISCORIG = C_NFENTR.CDNOTAFISCORIG;
            ELSE
               COMMIT;
            END IF;
         END IF;
      ELSE
         UPDATE SDX_CONTROLEINT
            SET DTIMPORTACAO = SYSDATE
          WHERE CDNOTAFISCORIG = C_NFENTR.CDNOTAFISCORIG;
      END IF;
   END LOOP;
/*Rotina de cancelamento das notas fiscais de Sada*/
   FOR C_NFSAID IN (SELECT SDX_NF.CDNOTAFISCORIG, SDX_NF.CDFILIAL,
                           SDX_NF.NRINSJURNF, SDX_NF.NRNOTAFISC,
                           SDX_NF.CDSERIE, SDX_NF.CDEMPRESA, SDX_NF.CDTIPOOPER, SDX_NF.DTENTRSAID
                      FROM SDX_NOTAFISCAL SDX_NF, SDX_CONTROLEINT SDX_CT
                     WHERE SDX_NF.CDNOTAFISCORIG = SDX_CT.CDNOTAFISCORIG
                       AND SDX_CT.DTIMPORTACAO IS NULL
                       AND SDX_CT.IDINSCANCNF = '2'
                       AND SDX_NF.IDENTRSAIDOP = 'S'
                       AND SDX_NF.CDFILIAL = P_CDFILIAL
                       AND SDX_NF.CDNOTAFISCORIG IN (SELECT SDX_CDNOTAFISCORIG
                                                           FROM NOTAFISCAL
                                                          WHERE SDX_CDNOTAFISCORIG IS NOT NULL)) LOOP
      BEGIN
         SELECT MAX(CDNOTAFISCORIG)
           INTO V_EXCANINS
           FROM SDX_CONTROLEINT
          WHERE CDNOTAFISCORIG = C_NFSAID.CDNOTAFISCORIG
            AND IDINSCANCNF    = '1'
            AND DTIMPORTACAO IS NULL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_EXCANINS := NULL;
      END;
      IF V_EXCANINS IS NULL THEN
         V_NFLOG := '';
         BEGIN
            SELECT NVL(IDCTRLESTQ, 'S')
              INTO V_IDCTRLESTQ
              FROM PARAMFILIAL
             WHERE CDFILIAL = C_NFSAID.CDFILIAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_DTPROCESSA := NULL;
               V_IDCTRLESTQ := 'S';
         END;
   /* Rotina para verificar se a filial da nota fiscal controla estoque */
         BEGIN
            SELECT NVL(IDATUESTTPOP, V_IDCTRLESTQ)
              INTO V_IDCTRLESTQ
              FROM TIPOOPERAC
             WHERE IDENTRSAIDOP = 'S'
               AND CDTIPOOPER = C_NFSAID.CDTIPOOPER;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_IDCTRLESTQ := V_IDCTRLESTQ;
         END;
   /*Busca a nota fiscal que dever ser cancelada*/
         BEGIN
            SELECT N.NRLANCTONF, N.NRLANCCONT, N.NRSEQLANC, L.NRLANCESTQ, N.DTENTRSAID, N.CDFILIEMIT
              INTO V_NRLANCTONF, V_NRLANCCONT, V_NRSEQLANC, V_NRLANCESTQ, V_DTENTRSAID, V_CDFILIEMIT
              FROM NOTAFISCAL N, LANCTOESTOQ L
                WHERE N.SDX_CDNOTAFISCORIG = C_NFSAID.CDNOTAFISCORIG
               AND N.CDFILIAL = L.CDFILIAL(+)
               AND N.NRLANCTONF = L.NRLANCTONF(+)
               AND N.IDENTRSAIDOP = 'S';
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NRLANCTONF := '';
               V_CDFILIAL   := '';
               V_NRLANCESTQ := '';
               V_DTENTRSAID := NULL;
               V_CDFILIEMIT := '';
         END;
   /*Se no houver relacionamentos, deleta as informaes importadas*/
         IF (V_NFLOG = '') OR (V_NFLOG IS NULL) THEN
   /*Cancela a Nota Fiscal*/
            DELETE FROM ITLANCTOEST
             WHERE NRLANCESTQ = V_NRLANCESTQ
               AND CDFILIAL = C_NFSAID.CDFILIAL;
            DELETE FROM LANCTOESTOQ
             WHERE NRLANCESTQ = V_NRLANCESTQ
               AND CDFILIAL = C_NFSAID.CDFILIAL;
            DELETE FROM ITEMENCARGO
             WHERE NRLANCTONF = V_NRLANCTONF
               AND CDFILIAL   = C_NFSAID.CDFILIAL;
            DELETE FROM AUDITORIA
             WHERE CDFILIALNF = C_NFSAID.CDFILIAL
               AND NRLANCTONF = V_NRLANCTONF;
            DELETE FROM ITEMNOTAFISC
             WHERE NRLANCTONF = V_NRLANCTONF
               AND CDFILIAL   = C_NFSAID.CDFILIAL;
            DELETE FROM ITEMPRODUTO
             WHERE NRLANCTONF = V_NRLANCTONF
               AND CDFILIAL   = C_NFSAID.CDFILIAL;
            DELETE FROM NFRELACAF
             WHERE NRLANCTONF = V_NRLANCTONF
               AND CDFILIAL   = C_NFSAID.CDFILIAL;
            DELETE FROM CONTARECEBER
             WHERE NRLANCTONF = V_NRLANCTONF
               AND CDFILIAL   = C_NFSAID.CDFILIAL;
            DELETE FROM NOTAFISCAL
             WHERE NRLANCTONF = V_NRLANCTONF
               AND CDFILIAL   = C_NFSAID.CDFILIAL;
   /*Grava a data de importao na tabela de controle*/
            UPDATE SDX_CONTROLEINT
               SET DTIMPORTACAO = SYSDATE
             WHERE CDNOTAFISCORIG = C_NFSAID.CDNOTAFISCORIG
               AND IDINSCANCNF = '2';
   /*Se houver algum relacionamento, insere a mensagem de log, informando que a nota no pode ser cancelada.*/
         ELSE
            UPDATE SDX_NOTAFISCAL
               SET DSOBSERVERROS = DSOBSERVERROS || V_NFLOG
             WHERE CDNOTAFISCORIG = C_NFSAID.CDNOTAFISCORIG;
         END IF;
         IF V_IDCTRLESTQ = 'S' THEN
            ATUALIZA_ESTOQUE(V_CDFILIEMIT, V_DTENTRSAID, V_DTENTRSAID, V_CDFILIAL, V_NRLANCESTQ);
            SELECT COUNT(*)
              INTO V_COUNTIRREG
              FROM MOVILOTE M, PRODFILI F, SDX_ITEMPRODUTO S, PRODUTO P
             WHERE M.NRMOVILOTE = V_CDFILIAL||V_NRLANCESTQ
               AND M.CDFILIAL   = V_CDFILIEMIT
               AND M.CDFILIAL   = F.CDFILIAL(+)
               AND M.CDPRODUTO  = F.CDPRODUTO(+)
               AND P.CDPRODUTO  = M.CDPRODUTO
               AND S.CDPRODUTO  = P.CDARVPROD
               AND NVL(M.CDALMOXARIFE,' ') = NVL(S.CDALMOXARIFE, ' ')
               AND NVL(M.CDLOCALESTOQ,' ') = NVL(S.CDLOCALESTOQ, ' ')
               AND NVL(F.IDCNTRESTOQ,'S')  = 'S';
            IF V_COUNTIRREG > 0 THEN
               V_PRIPROD := '0';
               FOR C_CANCE IN(SELECT DISTINCT NVL(P.CDARVPROD,'') AS PRODUTO
                                FROM MOVILOTE M, PRODUTO P, PRODFILI F, SDX_ITEMPRODUTO S
                               WHERE (NRMOVILOTE  = V_CDFILIAL||V_NRLANCESTQ)
                                 AND (M.CDFILIAL  = V_CDFILIAL)
                                 AND (M.CDPRODUTO = P.CDPRODUTO)
                                 AND (M.CDPRODUTO = F.CDPRODUTO(+))
                                 AND (M.CDFILIAL = F.CDFILIAL(+))
                                 AND (P.CDPRODUTO  = M.CDPRODUTO)
                                 AND (S.CDPRODUTO  = P.CDARVPROD)
                                 AND (NVL(M.CDALMOXARIFE,' ') = NVL(S.CDALMOXARIFE, ' '))
                                 AND (NVL(M.CDLOCALESTOQ,' ') = NVL(S.CDLOCALESTOQ, ' '))
                                 AND (NVL(F.IDCNTRESTOQ,'S')  = 'S')) LOOP
                  IF V_PRIPROD = '0' THEN
                      V_NFLOG := V_NFLOG || 'Lan. geraria irregularidade no estoque produtos: ';
                      V_PRIPROD := '1';
                  END IF;
                  V_NFLOG := V_NFLOG || C_CANCE.PRODUTO || '.* ';
               END LOOP;
               ROLLBACK;
               UPDATE SDX_NOTAFISCAL
                  SET DSOBSERVERROS = DSOBSERVERROS || V_NFLOG
                WHERE CDNOTAFISCORIG = C_NFSAID.CDNOTAFISCORIG;
               ATUALIZA_ESTOQUE(V_CDFILIEMIT, C_NFSAID.DTENTRSAID, C_NFSAID.DTENTRSAID, V_CDFILIAL, V_NRLANCESTQ);
               UPDATE SDX_CONTROLEINT
                  SET DTIMPORTACAO = NULL
               WHERE CDNOTAFISCORIG = C_NFSAID.CDNOTAFISCORIG;
            END IF;
         END IF;
      ELSE
         UPDATE SDX_CONTROLEINT
            SET DTIMPORTACAO = SYSDATE
          WHERE CDNOTAFISCORIG = C_NFSAID.CDNOTAFISCORIG;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('SDX_GERA_NOTAFISCAL','5.50.XXX'); END;
/

