/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: TRG_DTULTATU_UNIDMED                                                 */
/*                                                                            */
/* Descrio:                                                                 */
/* Atualiza a data de ultima atualizao da Unidade de Medida                 */
/*                                                                            */
/* Criao:                                                                   */
/* 02/05/2000 - Yoris L. de Souza                                             */
/*                                                                            */
/* Manutenes TRG :                                                          */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* @H:\SISTEMAS\DBA\SQL\ORACLE\TRG_DTULTATU_UNIDMED.SQL                     */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_UNIDMED'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER DTULTATU_UNIDMED
  GO

CREATE TRIGGER DTULTATU_UNIDMED
ON UNIDMEDIDA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'UNIDMEDIDA', 'SGUNIDADE=' + SGUNIDADE+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE UNIDMEDIDA
      SET DTULTATUUNID = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE
       ISNULL(UNIDMEDIDA.SGUNIDADE,0) = ISNULL(INSERTED.SGUNIDADE,0);
   END;
END;
GO

UPDATE UNIDMEDIDA SET DTULTATUUNID = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUUNID IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUUNID' and
            type = 'D')
   ALTER TABLE UNIDMEDIDA DROP CONSTRAINT DEFAULT_DTULTATUUNID
GO

ALTER TABLE UNIDMEDIDA ADD CONSTRAINT DEFAULT_DTULTATUUNID
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUUNID
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_UNIDMED','4.11.194';
GO

